| The Gaudi Framework v28r2p1 (f1a77ff4)

- Main Page
- Related Pages
- Modules
- Namespaces
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Types | Public Member Functions | Private Types | Private Member Functions | Static Private Member Functions | Private Attributes | Static Private Attributes | List of all members
Gaudi::Utils::SignalMonitorSvc Class Reference

Implementation of Gaudi::ISignalMonitor. More...

Inheritance diagram for Gaudi::Utils::SignalMonitorSvc:
[legend]
Collaboration diagram for Gaudi::Utils::SignalMonitorSvc:
[legend]

## Public Types
typedef struct sigaction | handler_t
Public Types inherited from extends< Service, Gaudi::ISignalMonitor >
using | base_class = extends
| Typedef to this class. More...
using | extend_interfaces_base = extend_interfaces< Interfaces... >
| Typedef to the base of this class. More...
Public Types inherited from Service
typedef Gaudi::PluginService::Factory< IService *, const std::string &, ISvcLocator * > | Factory
Public Types inherited from PropertyHolder< CommonMessaging< implements< IService, IProperty, IStateful > > >
using | PropertyHolderImpl = PropertyHolder< CommonMessaging< implements< IService, IProperty, IStateful > > >
| Typedef used to refer to this class from derived classes, as in. More...
Public Types inherited from CommonMessaging< implements< IService, IProperty, IStateful > >
using | base_class = CommonMessaging
Public Types inherited from extend_interfaces< Interfaces... >
using | ext_iids = typename Gaudi::interface_list_cat< typename Interfaces::ext_iids... >::type
| take union of the ext_iids of all Interfaces... More...

## Public Member Functions
void | monitorSignal (int signum, bool propagate) override
| Declare a signal to be monitored. More...
void | ignoreSignal (int signum) override
| Remove the specific signal handler for the requested signal, restoring the previous signal handler. More...
bool | gotSignal (int signum) const override
| Check if the given signal has been received. More...
void | setSignal (int signum) override
| Set the flag for the given signal, as if the signal was received. More...
void | clearSignal (int signum) override
| Clear the flag for the given signal, so that a new occurrence can be identified. More...
| SignalMonitorSvc (const std::string &name, ISvcLocator *svcLoc)
| Initialize internal variables of the service and set the instance pointer. More...
| ~SignalMonitorSvc () override
| Stop monitoring signals and clear the instance pointer. More...
Public Member Functions inherited from extends< Service, Gaudi::ISignalMonitor >
void * | i_cast (const InterfaceID &tid) const override
| Implementation of IInterface::i_cast. More...
StatusCode | queryInterface (const InterfaceID &ti, void **pp) override
| Implementation of IInterface::queryInterface. More...
std::vector< std::string > | getInterfaceNames () const override
| Implementation of IInterface::getInterfaceNames. More...
| ~extends () override=default
| Virtual destructor. More...
Public Member Functions inherited from Service
const std::string & | name () const override
| Retrieve name of the service. More...
StatusCode | configure () override
StatusCode | initialize () override
StatusCode | start () override
StatusCode | stop () override
StatusCode | finalize () override
StatusCode | terminate () override
Gaudi::StateMachine::State | FSMState () const override
Gaudi::StateMachine::State | targetFSMState () const override
StatusCode | reinitialize () override
StatusCode | restart () override
StatusCode | sysInitialize () override
| Initialize Service. More...
StatusCode | sysStart () override
| Initialize Service. More...
StatusCode | sysStop () override
| Initialize Service. More...
StatusCode | sysFinalize () override
| Finalize Service. More...
StatusCode | sysReinitialize () override
| Re-initialize the Service. More...
StatusCode | sysRestart () override
| Re-initialize the Service. More...
| Service (std::string name, ISvcLocator *svcloc)
| Standard Constructor. More...
SmartIF< ISvcLocator > & | serviceLocator () const override
| Retrieve pointer to service locator. More...
StatusCode | setProperties ()
| Method for setting declared properties to the values specified for the job. More...
template<class T >
StatusCode | service (const std::string &name, const T *&psvc, bool createIf=true) const
| Access a service by name, creating it if it doesn't already exist. More...
template<class T >
StatusCode | service (const std::string &name, T *&psvc, bool createIf=true) const
template<typename IFace = IService>
SmartIF< IFace > | service (const std::string &name, bool createIf=true) const
template<class T >
StatusCode | service (const std::string &svcType, const std::string &svcName, T *&psvc) const
| Access a service by name and type, creating it if it doesn't already exist. More...
template<class T >
StatusCode | declarePrivateTool (ToolHandle< T > &handle, std::string toolTypeAndName="", bool createIf=true)
| Declare used Private tool. More...
template<class T >
StatusCode | declarePublicTool (ToolHandle< T > &handle, std::string toolTypeAndName="", bool createIf=true)
| Declare used Public tool. More...
SmartIF< IAuditorSvc > & | auditorSvc () const
| The standard auditor service.May not be invoked before sysInitialize() has been invoked. More...
Public Member Functions inherited from PropertyHolder< CommonMessaging< implements< IService, IProperty, IStateful > > >
| PropertyHolder ()=default
| ~PropertyHolder () override=default
Gaudi::Details::PropertyBase & | declareProperty (Gaudi::Details::PropertyBase &prop)
| Declare a property. More...
Gaudi::Details::PropertyBase * | declareProperty (const std::string &name, TYPE &value, const std::string &doc="none")
| Helper to wrap a regular data member and use it as a regular property. More...
Gaudi::Details::PropertyBase * | declareProperty (const std::string &name, TYPE &value, const std::string &doc="none") const
Gaudi::Details::PropertyBase * | declareProperty (const std::string &name, Gaudi::Property< TYPE, VERIFIER, HANDLERS > &prop, const std::string &doc="none")
| Declare a PropertyBase instance setting name and documentation. More...
Gaudi::Details::PropertyBase * | declareRemoteProperty (const std::string &name, IProperty *rsvc, const std::string &rname="")
| Declare a remote property. More...
StatusCode | setProperty (const Gaudi::Details::PropertyBase &p) override
| set the property form another property More...
StatusCode | setProperty (const std::string &s) override
| set the property from the formatted string More...
StatusCode | setProperty (const std::string &n, const std::string &v) override
| set the property from name and the value More...
StatusCode | setProperty (const std::string &name, const TYPE &value)
| set the property form the value More...
StatusCode | getProperty (Gaudi::Details::PropertyBase *p) const override
| get the property More...
const Gaudi::Details::PropertyBase & | getProperty (const std::string &name) const override
| get the property by name More...
StatusCode | getProperty (const std::string &n, std::string &v) const override
| convert the property to the string More...
const std::vector< Gaudi::Details::PropertyBase * > & | getProperties () const override
| get all properties More...
bool | hasProperty (const std::string &name) const override
| Return true if we have a property with the given name. More...
| PropertyHolder (const PropertyHolder &)=delete
PropertyHolder & | operator= (const PropertyHolder &)=delete
Gaudi::Details::PropertyBase * | declareProperty (const std::string &name, GaudiHandleBase &ref, const std::string &doc="none")
| Specializations for various GaudiHandles. More...
Gaudi::Details::PropertyBase * | declareProperty (const std::string &name, GaudiHandleArrayBase &ref, const std::string &doc="none")
Gaudi::Details::PropertyBase * | declareProperty (const std::string &name, DataObjectHandleBase &ref, const std::string &doc="none")
Public Member Functions inherited from CommonMessagingBase
virtual | ~CommonMessagingBase ()=default
| Virtual destructor. More...
SmartIF< IMessageSvc > & | msgSvc () const
| The standard message service. More...
MsgStream & | msgStream () const
| Return an uninitialized MsgStream. More...
MsgStream & | msgStream (const MSG::Level level) const
| Predefined configurable message stream for the efficient printouts. More...
MsgStream & | always () const
| shortcut for the method msgStream(MSG::ALWAYS) More...
MsgStream & | fatal () const
| shortcut for the method msgStream(MSG::FATAL) More...
MsgStream & | err () const
| shortcut for the method msgStream(MSG::ERROR) More...
MsgStream & | error () const
| shortcut for the method msgStream(MSG::ERROR) More...
MsgStream & | warning () const
| shortcut for the method msgStream(MSG::WARNING) More...
MsgStream & | info () const
| shortcut for the method msgStream(MSG::INFO) More...
MsgStream & | debug () const
| shortcut for the method msgStream(MSG::DEBUG) More...
MsgStream & | verbose () const
| shortcut for the method msgStream(MSG::VERBOSE) More...
MsgStream & | msg () const
| shortcut for the method msgStream(MSG::INFO) More...
MSG::Level | msgLevel () const
| get the output level from the embedded MsgStream More...
MSG::Level | outputLevel () const __attribute__((deprecated))
| Backward compatibility function for getting the output level. More...
bool | msgLevel (MSG::Level lvl) const
| get the output level from the embedded MsgStream More...
Public Member Functions inherited from extend_interfaces< Interfaces... >
| ~extend_interfaces () override=default
| Virtual destructor. More...

## Private Types
enum | MonitoringMode { ignored, trap, propagate }
| Possible monitoring modes. More...

## Private Member Functions
void | i_handle (int signum)

## Static Private Member Functions
static void | setInstance (SignalMonitorSvc *i)
static SignalMonitorSvc * | instance ()
| Method to get the singleton instance. More...
static void | dispatcher (int signum)
| Signal handler function. More...

## Private Attributes
MonitoringMode | m_monitored [NSIG]
| Array of flags to keep track of monitored signals. More...
sig_atomic_t | m_caught [NSIG]
| Array of flags for received signals. More...
handler_t | m_defaultAction
| Helper variable for default signal action. More...
handler_t | m_oldActions [NSIG]
| List of replaced signal actions (for the recovery when disable the monitoring). More...

## Static Private Attributes
static SignalMonitorSvc * | s_instance = nullptr
| Pointer to the current instance. More...

## Additional Inherited Members
Protected Member Functions inherited from Service
| ~Service () override
| Standard Destructor. More...
int | outputLevel () const
| get the `Service's` output level More...
Protected Member Functions inherited from PropertyHolder< CommonMessaging< implements< IService, IProperty, IStateful > > >
Gaudi::Details::PropertyBase * | property (const std::string &name) const
Protected Member Functions inherited from CommonMessaging< implements< IService, IProperty, IStateful > >
void | updateMsgStreamOutputLevel (int level)
| Update the output level of the cached MsgStream. More...
Protected Attributes inherited from Service
Gaudi::StateMachine::State | m_state = Gaudi::StateMachine::OFFLINE
| Service state. More...
Gaudi::StateMachine::State | m_targetState = Gaudi::StateMachine::OFFLINE
| Service state. More...
Gaudi::Property< int > | m_outputLevel {this, "OutputLevel", MSG::NIL, "output level"}
Gaudi::Property< bool > | m_auditInit {this, "AuditServices", false, "[[deprecated]] unused"}
Gaudi::Property< bool > | m_auditorInitialize {this, "AuditInitialize", false, "trigger auditor on initialize()"}
Gaudi::Property< bool > | m_auditorStart {this, "AuditStart", false, "trigger auditor on start()"}
Gaudi::Property< bool > | m_auditorStop {this, "AuditStop", false, "trigger auditor on stop()"}
Gaudi::Property< bool > | m_auditorFinalize {this, "AuditFinalize", false, "trigger auditor on finalize()"}
Gaudi::Property< bool > | m_auditorReinitialize {this, "AuditReinitialize", false, "trigger auditor on reinitialize()"}
Gaudi::Property< bool > | m_auditorRestart {this, "AuditRestart", false, "trigger auditor on restart()"}
SmartIF< IAuditorSvc > | m_pAuditorSvc
| Auditor Service. More...

## Detailed Description

Implementation of Gaudi::ISignalMonitor.

If instantiated, intercepts the system signals and keep track of the recorded ones.

The signal to be monitored have to be declared via the method monitorSignal(). It can be interrogated to check if a signal has been received.

Definition at line 28 of file SignalMonitorSvc.cpp.

## Member Typedef Documentation

typedef struct sigaction Gaudi::Utils::SignalMonitorSvc::handler_t

Definition at line 34 of file SignalMonitorSvc.cpp.

## Member Enumeration Documentation

enum Gaudi::Utils::SignalMonitorSvc::MonitoringMode
| private

Possible monitoring modes.

Enumerator
ignored |
trap |
propagate |

Definition at line 110 of file SignalMonitorSvc.cpp.

110 {
111 ignored, //< the signal is not monitored
112 trap, //< the signal is monitored and not propagated to previously registered handlers
113 propagate //< the signal is monitored and propagated to previously registered handlers
114 };
Gaudi::Utils::SignalMonitorSvc::propagate
Definition: SignalMonitorSvc.cpp:113
Gaudi::Utils::SignalMonitorSvc::ignored
Definition: SignalMonitorSvc.cpp:111
Gaudi::Utils::SignalMonitorSvc::trap
Definition: SignalMonitorSvc.cpp:112

## Constructor & Destructor Documentation

Gaudi::Utils::SignalMonitorSvc::SignalMonitorSvc | ( | const std::string & | name,
|  | ISvcLocator * | svcLoc
| ) |  |
| inline

Initialize internal variables of the service and set the instance pointer.

Definition at line 83 of file SignalMonitorSvc.cpp.

83 : base_class( name, svcLoc )
84 {
85 #ifdef _WIN32
86 m_defaultAction = SIG_DFL;
87 #else
88 m_defaultAction.sa_handler = SIG_DFL;
89 sigemptyset( &m_defaultAction.sa_mask );
90 m_defaultAction.sa_flags = 0;
91 #endif
92 for ( int i = 0; i < NSIG; ++i ) {
93 m_caught[i] = 0;
94 m_monitored[i] = ignored;
95 m_oldActions[i] = m_defaultAction;
96 }
97
98 setInstance( this );
99 }
Gaudi::Utils::SignalMonitorSvc::m_caught
sig_atomic_t m_caught[NSIG]
Array of flags for received signals.
Definition: SignalMonitorSvc.cpp:118
extends< Service, Gaudi::ISignalMonitor >::base_class
extends base_class
Typedef to this class.
Definition: extends.h:14
Gaudi::Utils::SignalMonitorSvc::ignored
Definition: SignalMonitorSvc.cpp:111
Gaudi::Utils::SignalMonitorSvc::setInstance
static void setInstance(SignalMonitorSvc *i)
Definition: SignalMonitorSvc.cpp:145
Gaudi::Utils::SignalMonitorSvc::m_monitored
MonitoringMode m_monitored[NSIG]
Array of flags to keep track of monitored signals.
Definition: SignalMonitorSvc.cpp:116
Gaudi::Utils::SignalMonitorSvc::m_oldActions
handler_t m_oldActions[NSIG]
List of replaced signal actions (for the recovery when disable the monitoring).
Definition: SignalMonitorSvc.cpp:122
Gaudi::Utils::SignalMonitorSvc::m_defaultAction
handler_t m_defaultAction
Helper variable for default signal action.
Definition: SignalMonitorSvc.cpp:120

Gaudi::Utils::SignalMonitorSvc::~SignalMonitorSvc | ( |  | ) |
| inline override

Stop monitoring signals and clear the instance pointer.

Definition at line 102 of file SignalMonitorSvc.cpp.

103 {
104 for ( int i = 0; i < NSIG; ++i ) ignoreSignal( i );
105 setInstance( nullptr );
106 }
Gaudi::Utils::SignalMonitorSvc::ignoreSignal
void ignoreSignal(int signum) override
Remove the specific signal handler for the requested signal, restoring the previous signal handler...
Definition: SignalMonitorSvc.cpp:60
Gaudi::Utils::SignalMonitorSvc::setInstance
static void setInstance(SignalMonitorSvc *i)
Definition: SignalMonitorSvc.cpp:145

## Member Function Documentation

void Gaudi::Utils::SignalMonitorSvc::clearSignal | ( | int | signum | ) |
| inline override

Clear the flag for the given signal, so that a new occurrence can be identified.

Definition at line 80 of file SignalMonitorSvc.cpp.

80 { m_caught[signum] = 0; }
Gaudi::Utils::SignalMonitorSvc::m_caught
sig_atomic_t m_caught[NSIG]
Array of flags for received signals.
Definition: SignalMonitorSvc.cpp:118

void Gaudi::Utils::SignalMonitorSvc::dispatcher | ( | int | signum | ) |
| static private

Signal handler function.

Definition at line 156 of file SignalMonitorSvc.cpp.

157 {
158 if ( instance() ) instance()->i_handle( signum );
159 }
Gaudi::Utils::SignalMonitorSvc::i_handle
void i_handle(int signum)
Definition: SignalMonitorSvc.cpp:124
Gaudi::Utils::SignalMonitorSvc::instance
static SignalMonitorSvc * instance()
Method to get the singleton instance.
Definition: SignalMonitorSvc.cpp:149

bool Gaudi::Utils::SignalMonitorSvc::gotSignal | ( | int | signum | ) | const
| inline override

Check if the given signal has been received.

Definition at line 74 of file SignalMonitorSvc.cpp.

74 { return m_caught[signum] != 0; }
Gaudi::Utils::SignalMonitorSvc::m_caught
sig_atomic_t m_caught[NSIG]
Array of flags for received signals.
Definition: SignalMonitorSvc.cpp:118

void Gaudi::Utils::SignalMonitorSvc::i_handle | ( | int | signum | ) |
| inline private

Definition at line 124 of file SignalMonitorSvc.cpp.

125 {
126 m_caught[signum] = 1;
127 if ( m_monitored[signum] == propagate &&
128 #ifdef _WIN32
129 m_oldActions[signum] != SIG_DFL
130 #else
131 m_oldActions[signum].sa_handler != SIG_DFL
132 #endif
133 ) {
134 #ifdef _WIN32
135 m_oldActions[signum]( signum );
136 #else
137 m_oldActions[signum].sa_handler( signum );
138 #endif
139 }
140 }
Gaudi::Utils::SignalMonitorSvc::m_caught
sig_atomic_t m_caught[NSIG]
Array of flags for received signals.
Definition: SignalMonitorSvc.cpp:118
Gaudi::Utils::SignalMonitorSvc::propagate
Definition: SignalMonitorSvc.cpp:113
Gaudi::Utils::SignalMonitorSvc::m_monitored
MonitoringMode m_monitored[NSIG]
Array of flags to keep track of monitored signals.
Definition: SignalMonitorSvc.cpp:116
Gaudi::Utils::SignalMonitorSvc::m_oldActions
handler_t m_oldActions[NSIG]
List of replaced signal actions (for the recovery when disable the monitoring).
Definition: SignalMonitorSvc.cpp:122

void Gaudi::Utils::SignalMonitorSvc::ignoreSignal | ( | int | signum | ) |
| inline override

Remove the specific signal handler for the requested signal, restoring the previous signal handler.

Definition at line 60 of file SignalMonitorSvc.cpp.

61 {
62 if ( m_monitored[signum] ) {
63 #ifdef _WIN32
64 (void)signal( signum, m_oldActions[signum] );
65 #else
66 sigaction( signum, &m_oldActions[signum], nullptr );
67 #endif
68 m_oldActions[signum] = m_defaultAction;
69 m_monitored[signum] = ignored;
70 }
71 }
Gaudi::Functional::void
class MergingTransformer< Out(const vector_of_const_< In > void
Definition: MergingTransformer.h:19
Gaudi::Utils::SignalMonitorSvc::ignored
Definition: SignalMonitorSvc.cpp:111
std::signal
T signal(T...args)
Gaudi::Utils::SignalMonitorSvc::m_monitored
MonitoringMode m_monitored[NSIG]
Array of flags to keep track of monitored signals.
Definition: SignalMonitorSvc.cpp:116
Gaudi::Utils::SignalMonitorSvc::m_oldActions
handler_t m_oldActions[NSIG]
List of replaced signal actions (for the recovery when disable the monitoring).
Definition: SignalMonitorSvc.cpp:122
Gaudi::Utils::SignalMonitorSvc::m_defaultAction
handler_t m_defaultAction
Helper variable for default signal action.
Definition: SignalMonitorSvc.cpp:120

static SignalMonitorSvc* Gaudi::Utils::SignalMonitorSvc::instance | ( |  | ) |
| inline static private

Method to get the singleton instance.

Bypass the serviceLocator for efficiency.

Definition at line 149 of file SignalMonitorSvc.cpp.

149 { return s_instance; }
Gaudi::Utils::SignalMonitorSvc::s_instance
static SignalMonitorSvc * s_instance
Pointer to the current instance.
Definition: SignalMonitorSvc.cpp:143

void Gaudi::Utils::SignalMonitorSvc::monitorSignal | ( | int | signum,
|  | bool | propagate
| ) |  |
| inline override

Declare a signal to be monitored.

It installs a signal handler for the requested signal.

Definition at line 39 of file SignalMonitorSvc.cpp.

40 {
41 if ( !m_monitored[signum] ) {
42 handler_t sa;
43 handler_t oldact;
44 #ifdef _WIN32
45 sa = SignalMonitorSvc::dispatcher;
46 oldact = signal( signum, sa );
47 #else
48 sa.sa_handler = SignalMonitorSvc::dispatcher;
49 sigemptyset( &sa.sa_mask );
50 sa.sa_flags = 0;
51 sigaction( signum, &sa, &oldact );
52 #endif
53 m_oldActions[signum] = oldact;
54 m_monitored[signum] = ( propagate ) ? SignalMonitorSvc::propagate : SignalMonitorSvc::trap;
55 }
56 }
Gaudi::Utils::SignalMonitorSvc::propagate
Definition: SignalMonitorSvc.cpp:113
Gaudi::Utils::SignalMonitorSvc::dispatcher
static void dispatcher(int signum)
Signal handler function.
Definition: SignalMonitorSvc.cpp:156
std::signal
T signal(T...args)
Gaudi::Utils::SignalMonitorSvc::m_monitored
MonitoringMode m_monitored[NSIG]
Array of flags to keep track of monitored signals.
Definition: SignalMonitorSvc.cpp:116
Gaudi::Utils::SignalMonitorSvc::m_oldActions
handler_t m_oldActions[NSIG]
List of replaced signal actions (for the recovery when disable the monitoring).
Definition: SignalMonitorSvc.cpp:122
Gaudi::Utils::SignalMonitorSvc::trap
Definition: SignalMonitorSvc.cpp:112
Gaudi::Utils::SignalMonitorSvc::handler_t
struct sigaction handler_t
Definition: SignalMonitorSvc.cpp:34

static void Gaudi::Utils::SignalMonitorSvc::setInstance | ( | SignalMonitorSvc * | i | ) |
| inline static private

Definition at line 145 of file SignalMonitorSvc.cpp.

145 { s_instance = i; }
Gaudi::Utils::SignalMonitorSvc::s_instance
static SignalMonitorSvc * s_instance
Pointer to the current instance.
Definition: SignalMonitorSvc.cpp:143

void Gaudi::Utils::SignalMonitorSvc::setSignal | ( | int | signum | ) |
| inline override

Set the flag for the given signal, as if the signal was received.

Definition at line 77 of file SignalMonitorSvc.cpp.

77 { m_caught[signum] = 1; }
Gaudi::Utils::SignalMonitorSvc::m_caught
sig_atomic_t m_caught[NSIG]
Array of flags for received signals.
Definition: SignalMonitorSvc.cpp:118

## Member Data Documentation

sig_atomic_t Gaudi::Utils::SignalMonitorSvc::m_caught[NSIG]
| private

Array of flags for received signals.

Definition at line 118 of file SignalMonitorSvc.cpp.

handler_t Gaudi::Utils::SignalMonitorSvc::m_defaultAction
| private

Helper variable for default signal action.

Definition at line 120 of file SignalMonitorSvc.cpp.

MonitoringMode Gaudi::Utils::SignalMonitorSvc::m_monitored[NSIG]
| private

Array of flags to keep track of monitored signals.

Definition at line 116 of file SignalMonitorSvc.cpp.

handler_t Gaudi::Utils::SignalMonitorSvc::m_oldActions[NSIG]
| private

List of replaced signal actions (for the recovery when disable the monitoring).

Definition at line 122 of file SignalMonitorSvc.cpp.

Gaudi::Utils::SignalMonitorSvc * Gaudi::Utils::SignalMonitorSvc::s_instance = nullptr
| static private

Pointer to the current instance.

Definition at line 143 of file SignalMonitorSvc.cpp.

The documentation for this class was generated from the following file:

- GaudiUtils/src/component/SignalMonitorSvc.cpp